Scriptname MeatFarmCattleDrugsEffect extends ActiveMagicEffect  

zbfPlayerControl property zbfPC auto

Event OnEffectStart(Actor akTarget, Actor akCaster)
	registerForUpdate(6)
	ApplyEffects()
endEvent

Event OnUpdate()
	ApplyEffects()
endEvent



Function ApplyEffects()
	DisableFighting()
	;zbfPC.SetDisabledControls(abMovement = False, abFighting = true, abSneaking = False, abMenu = False, abActivate = False) ;prevent fighting
	;Game.SetBeastForm(True) ;prevents opening the character menu
endFunction



Event OnEffectFinish(Actor akTarget, Actor akCaster)
	UnregisterForUpdate()

	;Remove the Effects
	EnableFighting()
	;zbfPC.SetDisabledControls(abMovement = False, abFighting = false, abSneaking = False, abMenu = False, abActivate = False)
	;Game.SetBeastForm(False)
endEvent



;These two functions disable/enable fighting WITHOUT affecting the rest of Player Controls

Function DisableFighting()
	int x = zbfPC.iControlMask
	
	;if the '2s' digit (in binary) is 1, the fighting is already disabled
	;if the digit is zero, then it is enabled

	if Math.LogicalAnd(x, 0x2) == 0 ;if fighting is currently enabled
		x = x + 2 ;disable it
	endIf

	zbfPC.iControlMask = x
	zbfPC.InternalReapplyPlayerControls()
endFunction


Function EnableFighting()
	int x = zbfPC.iControlMask

	if Math.LogicalAnd(x, 0x2) != 0 ;if fighting is currently disabled
		x = x - 2 ;enable it
	endIf

	zbfPC.iControlMask = x
	zbfPC.InternalReapplyPlayerControls()
endFunction