Scriptname MeatFarmCattleMenu extends Quest  

;Properties
SexLabFramework property SexLab auto
sslActorLibrary property ActorLib auto
MeatFarmMCM property MCM auto
Message property FirstMenu auto
Actor property PlayerActor auto
GlobalVariable Property GameDaysPassed  Auto 


;Races
Race property Nord auto
Race property Imperial auto
Race property Redguard auto
Race property Breton auto


;Stats
Int property CattleID auto
Int property  DaysAsCattle auto
Float property  Marbling auto
Float property Weight auto

;Logistical Stuff
Bool Uninitialized = true
String msg
String Breed

Event OnInit()
	if Uninitialized
		;initialize
		DaysAsCattle = 0
		CattleID = utility.randomInt(101,399)
		breed = GetBreed(PlayerActor)
		weight = Game.GetPlayer().GetActorBase().GetWeight() *2.2  ;value in pounds
		Marbling = 25 + Utility.RandomInt(0,10)                  ;+ Utility.RandomInt(0,1)*35

		RegisterForKey(MCM.CattleMenuButton)
		Uninitialized = false
	endIf
EndEvent

Event OnKeyDown(Int keycode) ;this handles the keypress for when player opens the cattle menu
	if keycode == MCM.CattleMenuButton &&  !(Utility.IsInMenuMode()) && Self.IsRunning()
		ShowMenu()
	endIf
EndEvent


Function ChangeButton(int keycode) ;This is called by the MCM if the button is changed
		UnregisterForKey(MCM.CattleMenuButton)
		MCM.CattleMenuButton = keycode
		RegisterForKey(MCM.CattleMenuButton)
endFunction


Function ShowMenu() ;Shows the first menu will all the cattle menu options
	int option
	option = FirstMenu.Show()
		
	if option == 0 ;check stats
		Display() ;Display the stats
	elseif option ==1 ;sit
		Debug.SendAnimationEvent(PlayerActor , "IdleSitCrossLeggedEnter")
	elseif option ==2 ; masturbate
		SexLab.QuickStart(PlayerActor)
	elseif option == 3 ; close menu
		;nothing
	endif
	
	;sitting seems to work, but not these two:
	;Debug.SendAnimationEvent(PlayerActor , "IdleLaydown_Enter")
	;Debug.SendAnimationEvent(PlayerActor , "IdleLaydown_Exit")
			;IdleLaydown_enter
endFunction

Function Display()
	if Marbling > 99
		Marbling = 99
	endIf
	if Marbling < 1
		marbling = 1
	endIf
	msg = "Cattle ID: " + CattleID +"\n"
	msg += "Cattle Breed: " + GetBreed(PlayerActor) +"\n"
	msg += "Days as Cattle: " + DaysAsCattle +"\n"
	msg += "Approx. Yield: " + Weight as Int+" lbs" +"\n"
	msg += "Marbling: " + StringUtil.Substring(marbling,0,5) +"%" +"\n"
	msg += "An ideal marbling is between 45% and 55%"
	debug.messagebox(msg)
endFunction

Int  Function Evaluate()  ;This is used in the Player Eval Quest
	;checks if player can be approved for slaughter and return the appropriate scenario's quest stage
	
	If DaysAsCattle >= MCM.MaxDays ;default is 120 days
		return 94 ;too old, slaughter immediately
	elseif marbling < 45
		return 91 ;too skinny
	elseIf  marbling > 55
		return 92 ;too fat
	elseIf marbling > 45 &&  marbling < 55
		return 93 ;ready for slaughter
	endif
endFunction


function Sex(actor target)
	Actor player = Game.GetPlayer()
	;Get player's sex/gender
	int PlayerSex = ActorLib.GetGender(player)
	;int PlayerSex =  player.GetActorBase().GetSex()
	
	;Start sex
	if PlayerSex == 0 ;male
		QuickStartNoBeds(target, player)
	elseif  PlayerSex == 1 ;female
		QuickStartNoBeds(player, target)
	endIf
	
	;Update Marbling
	Float Decrease
	Decrease = Marbling / 130 * MCM.SexMultiplier
	Marbling = Marbling - Decrease
	if Marbling < 1
		Marbling = 1
	endIf
	utility.wait(12)
	debug.notification("Marbling decreased by " + Decrease)
endFunction


sslThreadController function QuickStartNoBeds(Actor Actor1, Actor Actor2 = none, Actor Actor3 = none, Actor Actor4 = none, Actor Actor5 = none, Actor Victim = none, string Hook = "", string AnimationTags = "")
	Actor[] Positions = SexLabUtil.MakeActorArray(Actor1, Actor2, Actor3, Actor4, Actor5)
	sslBaseAnimation[] Anims
	if AnimationTags != ""
		Anims = SexLab.AnimSlots.GetByTags(Positions.Length, AnimationTags, "", false)
	endIf
	return SexLab.ThreadSlots.GetController(SexLab.StartSex(Positions, Anims, Victim, none, false, Hook))
endFunction

String Function GetBreed(Actor X)
	Race xRace
	xRace = X.GetActorBase().GetRace()
	if xRace == Nord
		return "Nord meatslave"
	elseif xRace == imperial
		return "Imperial meatslave"
	elseif xRace == redguard
		return "Redguard meatslave"
	elseif xRace == breton
		return "Breton meatslave"
	else
		return "NonHuman meatslave"
	endIf
endFunction
