Scriptname MeatFarmFollowerHandler extends Quest  


MeatFarmMCM property MCM auto
Quest property DialogueFollower auto
Actor property Follower auto
Bool property Convinced = false auto
Outfit property MeatOutfit auto
DialogueFollowerScript property DFS auto

Faction property KillableCattle auto
ObjectReference property Cage1 auto

Event OnInit()
	RegisterForUpdate(6)
endEvent


Event OnUpdate()
	;Check if there is a new follower or if the follower has left
	Actor NewFollower = (DialogueFollower.GetAlias(0) as ReferenceAlias).GetActorRef()

	If Follower != NewFollower
		Follower = NewFollower
		(self.GetAlias(0) as ReferenceAlias).ForceRefTo(Follower) ;set them as the new follower

		if self.GetStage() != 30 ;only if player has the dialogue enabled
			self.Reset() ;this is needed when going from a high stage to a lower one
			self.SetStage(0) ;reset the dialogue
		endIf
		Convinced = false ;the new follower has to be convinced again
	endIf
endEvent

Function ConvinceFollower()
	convinced = true ;follower has been convinced to join the player
	self.SetStage(10) ;makes the dialogue disappear

	;debug.notification("MeatFarm: Your follower will join you if you go to the meat farm.")
EndFunction

Function SendFollowerToFarm()
	UnRegisterForUpdate()
	Follower.MoveTo(Cage1)
	DFS.DismissFollower()
	Follower.SetOutfit(MeatOutfit)
	Follower.RemoveAllItems()
	Follower.AddItem(MCM.Collar)
	Follower.EquipItem(MCM.Collar)
	Follower.AddToFaction(KillableCattle)
endFunction