Scriptname MeatFarmMCM extends SKI_ConfigBase

;Script imports
SexLabFramework property SexLab auto
zbfPlayerControl property zbfPC auto
MeatFarmCattleMenu property CattleMenu auto
MeatFarmScheduler property Scheduler auto
MeatFarmSkipHandler property Skipper auto
MeatFarmFollowerHandler property FH auto
QF_MeatFarmCagedMeatslaves_04004C91 property CageHandler auto

;Game objects
Spell property CattleDrugs auto
Key property MasterKey auto
ObjectReference property PlayerItemsChest auto
ImageSpaceModifier property PoisonHit auto
Armor property collar auto

;Option variables
Int property MaxDays auto
Float Property FoodMultiplier auto
Float property SexMultiplier auto
Bool property DADebugCodes = false auto
int property CattleMenuButton auto
{default is 'Q' = 16}
Int property AskSkipButton auto
{Default is 'Y' = 21}


;OID
int aOID ;master key
int bOID
int cOID ;cattle menu button
int dOID ;MaxDays
int eOID ;multiplier food
int fOID ;multiplier sex
int gOID ;skip time button
int hOID ;test stuff
int iOID ;skip startquest
int jOID ;return taken items
int kOID ;remove cattle drugs effect
int mOID ;follower can be meat
int nOID ;Who is follower
int oOID ;is follower convinced?
int pOID ;force start new day
int qOID ;force a restock

;Vals
bool aVal = false
bool bVal = false
bool cVal = false
bool kVal = false
bool mVal = true


event OnPageReset(string page)

	if page == "Main"
		SetCursorFillMode(TOP_TO_BOTTOM)
		AddHeaderOption("Keybinds")
		cOID = AddKeyMapOption("Open Cattle Menu", CattleMenuButton)
		gOID = AddKeyMapOption("Skip Time", AskSkipButton)
	
		AddHeaderOption("Quest Options")
		dOID = AddSliderOption("Low Quality", MaxDays , "After {0} days")
	
		AddHeaderOption("Difficulty")
		eOID = AddSliderOption("Marbling Increase Multiplier (Food)", FoodMultiplier , "{1}")
		fOID = AddSliderOption("Marbling Decrease Multiplier (Sex)", SexMultiplier , "{1}")
	
	elseif page == "Followers"
		SetCursorFillMode(TOP_TO_BOTTOM)
		;AddHeaderOption("Followers")
		mOID = AddToggleOption("Follower Dialogue", mVal)
		nOID = AddTextOption("Current Follower", FH.Follower.GetActorBase().GetName())
		oOID = AddTextOption("Follower Convinced", FH.Convinced as String)

	elseIf page == "Mod Control"
		SetCursorFillMode(TOP_TO_BOTTOM)
		;AddHeaderOption("Controls")
		kOID = AddToggleOption("Cattle Drugs effect", kVal)
		iOID = AddTextOption("Become a Meatslave Now", "Click Me!")
		jOID = AddTextOption("Return removed items", "Click Me!")

	elseIf page == "Debug"
		SetCursorFillMode(TOP_TO_BOTTOM)
		;AddHeaderOption("Debugging")
		aOID = AddToggleOption("Give Master Key", aVal)
		bOID = AddToggleOption("Daily Event Debug Codes", bVal)
		;hOID = AddTextOption("Test a thing", "Click Me!")
		pOID = AddTextOption("Force start new day", "Click Me!")
		qOID = AddSliderOption("Force restock N meatslaves", 0,"{0}")

	endIf
endEvent

event OnOptionSelect(int option)
	If option == aOID
		aVal = !aVal
		SetToggleOptionValue(aOID, aVal)
		if aVal
			Game.GetPlayer().AddItem(MasterKey)
		else
			Game.GetPlayer().RemoveItem(MasterKey)
		endIf

	elseIf option == bOID
		bVal = !bVal
		SetToggleOptionValue(bOID, bVal)
		if bVal
			DADebugCodes = true
		else
			DADebugCodes = false
		endIf

	elseIf option == iOID ;skip the intro quest
		debug.messagebox("You are about to be stripped naked and sent to the Meat Farm. Close all menus to proceed")
		utility.wait(0.1)
		SendModEvent("MeatFarm_InstantSendToFarm") ;this is registered in MeatFarmStartQuest

	elseIf option == hOID
		utility.wait(0.1)
		;EpilogueScript.Test()
		
	elseIf option == jOID ;return the player's items
		debug.messagebox("Your items will be returned to you. Close all menus to proceed.")
		utility.wait(0.1)
		PlayerItemsChest.RemoveAllItems( Game.GetPlayer(), false, true)
		debug.messagebox("Items returned.")
	
	elseIf option == kOID
		kVal = !kVal
		SetToggleOptionValue(kOID, kVal)
		debug.messagebox("Close all menus to proceed.")
		utility.wait(0.1)
		if kVal
			ApplyCattleDrugs()
		else
			RemoveCattleDrugs()
		endIf

	elseIf option == mOID
		mVal = !mVal
		SetToggleOptionValue(mOID, mVal)
		if mVal
			utility.wait(0.1)
			FH.Reset() ;needed when going from a higher stage to a lower one
			FH.SetStage(0)
		else
			utility.wait(0.1)
			FH.Setstage(30)
		endIf

	elseIf option == pOID
		debug.messagebox("Forcing a new day. Close all menus.")
		utility.wait(0.1)
		Scheduler.ForceStartNewDay()

	endIf
endEvent


event OnOptionKeyMapChange(int option, int keyCode, string conflictControl, string conflictName)
	if option == cOID ;player wishes to change the button to open cattle menu
		SetKeyMapOptionValue( cOID, keyCode)
		CattleMenu.ChangeButton(keycode)
	endIf
	if option == gOID ;skip time button
		SetKeyMapOptionValue( gOID, keyCode)
		Skipper.ChangeButton(keycode)
	endIf
endEvent


event OnOptionSliderOpen(int option)
	if (option == dOID)
		SetSliderDialogStartValue(MaxDays)
		SetSliderDialogDefaultValue(120)
		SetSliderDialogRange(10,800)
		SetSliderDialogInterval(10)
	elseif (option == eOID)
		SetSliderDialogStartValue(FoodMultiplier)
		SetSliderDialogDefaultValue(1.0)
		SetSliderDialogRange(1.0,6.0)
		SetSliderDialogInterval(0.1)
	elseif (option == fOID)
		SetSliderDialogStartValue(SexMultiplier)
		SetSliderDialogDefaultValue(1.0)
		SetSliderDialogRange(1.0,6.0)
		SetSliderDialogInterval(0.1)
	elseif (option == qOID)
		SetSliderDialogStartValue(0)
		SetSliderDialogDefaultValue(0)
		SetSliderDialogRange(0,10)
		SetSliderDialogInterval(1)
	endIf
endEvent

event OnOptionSliderAccept(int option, float value)
	if (option == dOID)
		MaxDays = (value as Int)
		SetSliderOptionValue(dOID, MaxDays, "After {0} days")
	elseif (option == eOID)
		FoodMultiplier = value
		SetSliderOptionValue(eOID, FoodMultiplier , "{1}")
	elseif (option == fOID)
		SexMultiplier = value
		SetSliderOptionValue(fOID, SexMultiplier , "{1}")
	elseif (option == qOID)
		;force restock, this is special
		CageHandler.KilledCattle = value as int
		debug.messagebox("Forcing a restock. Close all menus.")
		utility.wait(0.1)
		CageHandler.RestockNoMsg()
	endIf
endEvent

event OnOptionHighlight(int option)
	if option == dOID
		SetInfoText("The maximum amount of days as cattle after which you will be considered too old and slaughtered at your next evaluation.")
	elseif option == eOID
		SetInfoText("Multiply how much marbling you get when eating from the trough. Higher values make the game easier.")
	elseif option == fOID
		SetInfoText("Multiply how much marbling you lose from sex while in the cage. Higher values make the game easier.")
	elseif option == iOID
		SetInfoText("Strip you of your items and send you to the Meat Farm. You can also use this to skip the starting quest.")
	elseIf option == jOID
		SetInfoText("Returns the items that were taken from you during recruitment. Technically (storywise), these were donated to the Thalmor, but you can press this button to get them back.")
	elseIf option == kOID
		SetInfoText("Enable/Disable the effect which makes meatslaves more docile. On the player, it prevents them from attacking. \n Uncheck this if you have escaped the farm and want to remove the effect.")	
	elseif option == mOID
		SetInfoText("Can ask follower about becoming a meatslave with you.")
	elseif option == oOID
		SetInfoText("True if the follower has agreed to join you on the farm if you become a meatslave.")	
	endIf
endEvent






;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; Other Tool Functions ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Function GiveCollar()
	Actor player = Game.GetPlayer()
	player.AddItem(collar,1,true)
	player.EquipItem(collar)
EndFunction

Function ApplyCattleDrugs()
	PoisonHit.Apply(3)
	Game.GetPlayer().AddSpell(CattleDrugs)
	;debug.notification("Cattle Drugs effect applied")
	cVal = True
EndFunction

Function RemoveCattleDrugs()
	Game.GetPlayer().RemoveSpell(CattleDrugs)
	debug.notification("Cattle Drugs effect removed")
	cVal = False
EndFunction












;;;;;;;;;;DEPRECATED SECTION, keeping this here for future reference

Function ClonePlayerTest()
	actor player = Game.Getplayer()
	ActorBase MyActorBase = player.GetBaseObject() as ActorBase
	player.PlaceActorAtMe(MyActorBase)
endFunction

Function DeathSoundTest()
	Game.SetGameSettingFloat("fPlayerDeathReloadTime",360) ;set it to 6 minutes
	Game.GetPlayer().Kill()
	MuteDroning()
	utility.wait(1)
	StartEpilogueMusic()
	debug.messagebox("Put Epilogue text here")
	utility.wait(1)
	debug.messagebox("Resetting Sound Levels")
	ResetSoundLevels()
endFunction


Function MuteDroningGradually() ;DEPRECATED?
	;This function gradually removes that annoying droning sound after you die that seems to loop forever
	;unfortunately, this method seems to mute all sounds under the Effects category.
	;in the future I'll have to narrow down on this one specific sound
	
	;process occurs over ~2 seconds
	float  i = 1.0
	While i >= 0.0
		;AudioCategorySFX .SetVolume(i)
		i = i - 0.1
		utility.wait(0.2)
	endWhile
endFunction


;SoundCategory property AudioCategorySFX auto
;SoundCategory property AudioCategoryMUS auto
;MusicType property MeatFarmEpilogueMusic auto


Function MuteDroning()
	;AudioCategorySFX.Mute()
endFunction

Function StartEpilogueMusic()
		;AudioCategoryMUS.SetVolume(0.7)
		;MeatFarmEpilogueMusic.Add() ;play some nice music
endFunction

Function ResetSoundLevels()
	;the defaults are 0.5 for music and 1.0 for effects. So reset to those
	;AudioCategoryMUS.SetVolume(0.5)
	;;;;;;;;;;;;;;;;;;;;;;;;AudioCategorySFX .SetVolume(1.0)
	;AudioCategorySFX.UnMute()
endFunction

