Scriptname MeatFarmSkipHandler extends Quest  


Bool property CanSkipNow = false auto 
Globalvariable property TimeScale auto
GlobalVariable property GameHour auto
MeatFarmMCM property MCM auto

Int ConfirmSkipButton = 28  ;this is the 'Enter' key
Bool PrimedToSkip = false

event OnInit()
	RegisterForKey(MCM.AskSkipButton)
	RegisterForKey(ConfirmSkipButton)
	RegisterForModEvent("MeatFarm_EnableSkip","OnEnableSkip")
endEvent

Event OnKeyDown(Int keycode)
	if keycode == MCM.AskSkipButton && !(Utility.IsInMenuMode())
		if CanSkipNow 
			Debug.notification("Skip ahead? Press Enter to confirm")
			PrimedToSkip = true
			RegisterForSingleUpdate(4.0) ;after X seconds, 'unprime' the skip
		else
			Debug.notification("You cannot skip right now.")
		endIf
	elseIf keycode == ConfirmSkipButton && PrimedToSkip && !(Utility.IsInMenuMode())
		PrimedToSkip = false
		CanSkipNow = false ;make it so player can only skip time once per day (when a daily event finishes it resets this)
		Skip()
	endIf
EndEvent

event OnUpdate()
	PrimedToSkip = false
endEvent

Event OnEnableSkip(string eventName, string strArg, float numArg, Form sender)
	utility.wait(3) ; this pause is just for cadence
	CanSkipNow = true
	debug.notification("You can now skip ahead")
endEvent

Function ChangeButton(int keycode) ;This is called by the MCM if the button is changed
		UnregisterForKey(MCM.AskSkipButton)
		MCM.AskSkipButton= keycode
		RegisterForKey(MCM.AskSkipButton)
endFunction

function Skip(float TargetTime = 8.15) ;This will skip to a given time, default 8:10 am

	Game.DisablePlayerControls()
	Debug.SendAnimationEvent(Game.GetPlayer() , "IdleSitCrossLeggedEnter")
	utility.wait(1)
	
	;First skip to 0:00 am (if it is already past <toTime> today)
	Timescale.SetValue(12000)
	While GameHour.GetValue() > TargetTime 
		utility.wait(0.1)
	endWhile

	;then skip to TargetTime 
	Timescale.SetValue(12000)
	While GameHour.GetValue() < TargetTime 
		utility.wait(0.1)
	endWhile

	Timescale.SetValue(20)
	utility.wait(1)
	Game.EnablePlayerControls()
	utility.wait(1)
	Game.RequestAutoSave()
endFunction


