Scriptname MeatFarmTroughScript extends ObjectReference  

MeatFarmCattleMenu property CattleMenu auto
Sound property EatSound auto
MeatFarmMCM property MCM auto

Bool property IsNotFull auto
{default is true}
Int property TimesEatenToday auto
{default 0}

Event OnActivate(ObjectReference akActivator)
	if IsNotFull
		Eat()
		TimesEatenToday += 1
		if  TimesEatenToday >= 2
			IsNotFull = false
		endIf
	else
		debug.notification("You are too full to keep eating.")
	endIf
endEvent

Function Eat()
	
	Float Increase
	Increase = (6 - CattleMenu.Marbling/17)/10 * MCM.FoodMultiplier
	CattleMenu.Marbling = CattleMenu.Marbling + Increase
	if CattleMenu.Marbling > 99
		CattleMenu.Marbling = 99
	endIf
	debug.notification("Marbling increased by " + Increase)
	
	;Play eating noises
	int i = 0
	While i < 5
			EatSound.Play(self)
			i = i + 1
			utility.wait(0.4)
	endWhile
	
	SendModEvent("MeatFarm_INeed_TroughEating")
endFunction