;BEGIN FRAGMENT CODE - Do not edit anything between this and the end comment
;NEXT FRAGMENT INDEX 16
Scriptname QF_MeatFarmStartQuest_0500E7DA Extends Quest Hidden

;BEGIN ALIAS PROPERTY Cattle_Cart
;ALIAS PROPERTY TYPE ReferenceAlias
ReferenceAlias Property Alias_Cattle_Cart Auto
;END ALIAS PROPERTY

;BEGIN ALIAS PROPERTY CartEnter
;ALIAS PROPERTY TYPE ReferenceAlias
ReferenceAlias Property Alias_CartEnter Auto
;END ALIAS PROPERTY

;BEGIN ALIAS PROPERTY Recruiter
;ALIAS PROPERTY TYPE ReferenceAlias
ReferenceAlias Property Alias_Recruiter Auto
;END ALIAS PROPERTY

;BEGIN ALIAS PROPERTY RemoveAllChest
;ALIAS PROPERTY TYPE ReferenceAlias
ReferenceAlias Property Alias_RemoveAllChest Auto
;END ALIAS PROPERTY

;BEGIN ALIAS PROPERTY Arrival_Xmarker
;ALIAS PROPERTY TYPE ReferenceAlias
ReferenceAlias Property Alias_Arrival_Xmarker Auto
;END ALIAS PROPERTY

;BEGIN FRAGMENT Fragment_3
Function Fragment_3()
;BEGIN CODE
;Give the book to player
Game.GetPlayer().Additem(MeatFarmBook)
;END CODE
EndFunction
;END FRAGMENT

;BEGIN FRAGMENT Fragment_7
Function Fragment_7()
;BEGIN CODE
;Player has spoken to recruiter after signing contract
SetObjectiveCompleted(30)

;Remove the contract from the player
Game.GetPlayer().RemoveItem(Contract)

;Tell player to use the chest
SetObjectiveDisplayed(40)
;END CODE
EndFunction
;END FRAGMENT

;BEGIN FRAGMENT Fragment_14
Function Fragment_14()
;BEGIN CODE
;Move the player to the farm
Game.SetPlayerAIDriven(false)
Game.FastTravel(Alias_Arrival_Xmarker.GetRef())
utility.wait(0.5)
Game.RequestAutoSave()

;Start the necessary quests
MeatFarmInitialProcessing.Start()
CattleMenu.Start()
CheckFollower()
;don't start the scheduler until player actually gets in the cage.

SetStage(400)
;END CODE
EndFunction
;END FRAGMENT

;BEGIN FRAGMENT Fragment_0
Function Fragment_0()
;BEGIN CODE
;Tell player to notify the recruiter of their decision
SetObjectiveDisplayed(10)

;If started, complete the InnDialogue Quest
MeatFarmInnDialogue.CompleteQuest()
;END CODE
EndFunction
;END FRAGMENT

;BEGIN FRAGMENT Fragment_15
Function Fragment_15()
;BEGIN CODE
;Don't stop the quest (trust me......)
;Stop()
;END CODE
EndFunction
;END FRAGMENT

;BEGIN FRAGMENT Fragment_13
Function Fragment_13()
;BEGIN CODE
;Player has entered the cart
SetObjectiveCompleted(60)
Game.SetPlayerAIDriven(true)

;Let the animation play out
utility.wait(5)

;Go to final stage
SetStage(80)
;END CODE
EndFunction
;END FRAGMENT

;BEGIN FRAGMENT Fragment_6
Function Fragment_6()
;BEGIN CODE
;The player has read and signed the contract
SetObjectiveCompleted(20)

;Tell player to return contract
SetObjectiveDisplayed(30)
;END CODE
EndFunction
;END FRAGMENT

;BEGIN FRAGMENT Fragment_11
Function Fragment_11()
;BEGIN CODE
;Player has spoken to recruiter again
SetObjectiveCompleted(50)

;Tell player to get in cart
SetObjectiveDisplayed(60)
;END CODE
EndFunction
;END FRAGMENT

;BEGIN FRAGMENT Fragment_10
Function Fragment_10()
;BEGIN CODE
;Player has used the chest
SetObjectiveCompleted(40)

;Remove all items from player
Game.GetPlayer().RemoveAllItems(PlayerItemsChest, False, True)

;Tell player to speak to recruiter again
SetObjectiveDisplayed(50)
;END CODE
EndFunction
;END FRAGMENT

;BEGIN FRAGMENT Fragment_5
Function Fragment_5()
;BEGIN CODE
;player has decided to be meatslave
SetObjectiveCompleted(10)

;Give the contract
Game.GetPlayer().Additem(Contract)

;Tell player to Read and sign it
SetObjectiveDisplayed(20)
;END CODE
EndFunction
;END FRAGMENT

;END FRAGMENT CODE - Do not edit anything between this and the begin comment

Book Property MeatFarmBook  Auto 
Book Property Contract auto

Quest Property MeatFarmInitialProcessing  Auto  
Quest Property CattleMenu  Auto  
Quest property MeatFarmInnDialogue auto
MeatFarmFollowerHandler property FH auto
ObjectReference property PlayerItemsChest auto


event OnInit()
	if GetStage() == 0
		;this will make it so the Recruiter's dialogue appears without having to quicksave + Reload
		Start()
	endIf

	RegisterForModEvent("MeatFarm_InstantSendToFarm", "OnSendToFarm")
endEvent

Event OnSendToFarm(string eventName, string strArg, float numArg, Form sender)
	if IsStopped()
		Start()
		debug.messagebox("Please wait a few seconds.")
		utility.wait(3)
	endIf
	Game.GetPlayer().RemoveAllItems(PlayerItemsChest, False, True)
	SetStage(80)
endEvent 


Function CheckFollower()
	if FH.Convinced == True
		FH.SendFollowerToFarm()
	endIf
EndFunction
