;BEGIN FRAGMENT CODE - Do not edit anything between this and the end comment
;NEXT FRAGMENT INDEX 14
Scriptname QF__050125D9 Extends Quest Hidden

;BEGIN ALIAS PROPERTY Guard
;ALIAS PROPERTY TYPE ReferenceAlias
ReferenceAlias Property Alias_Guard Auto
;END ALIAS PROPERTY

;BEGIN ALIAS PROPERTY Staircase
;ALIAS PROPERTY TYPE ReferenceAlias
ReferenceAlias Property Alias_Staircase Auto
;END ALIAS PROPERTY

;BEGIN ALIAS PROPERTY BreedingCage
;ALIAS PROPERTY TYPE ReferenceAlias
ReferenceAlias Property Alias_BreedingCage Auto
;END ALIAS PROPERTY

;BEGIN ALIAS PROPERTY Pillory
;ALIAS PROPERTY TYPE ReferenceAlias
ReferenceAlias Property Alias_Pillory Auto
;END ALIAS PROPERTY

;BEGIN ALIAS PROPERTY male
;ALIAS PROPERTY TYPE ReferenceAlias
ReferenceAlias Property Alias_male Auto
;END ALIAS PROPERTY

;BEGIN FRAGMENT Fragment_7
Function Fragment_7()
;BEGIN CODE
;Make the bull face the player
Male.PathToReference(player,1)

utility.wait(0.5)
debug.notification("The breeding bull sees you bent over and instincts kick in")

;Have a very long sex scene (that's still skippable)
PillorySex2(player, male, Alias_pillory.GetRef())
;END CODE
EndFunction
;END FRAGMENT

;BEGIN FRAGMENT Fragment_12
Function Fragment_12()
;BEGIN CODE
;Have the guard walk away from the cage
;(so that he doesnt accidently walk inside)

GuardWalkAway.Start()

SetStage(40)
;END CODE
EndFunction
;END FRAGMENT

;BEGIN FRAGMENT Fragment_9
Function Fragment_9()
;BEGIN CODE
;This is the stage immediately after the pillory sex ends

;When the pillory reappears the player can get caught in it weirdly, so use this
player.moveto(Alias_breedingcage.GetRef())
male.moveto(player)

;return control
utility.wait(0.5)
debug.notification("The device unlocks and you are free")
Game.EnablePlayerControls()
Game.SetPlayerAIDriven(false)

;Tell player to re-enter the breeding device or go to sleep
SetObjectiveDisplayed(20)

SetStage(60)
;END CODE
EndFunction
;END FRAGMENT

;BEGIN FRAGMENT Fragment_6
Function Fragment_6()
;BEGIN CODE
;Disable the actors and move them to the staircase
male.disable()
guard.disable()

Guard.MoveTo(alias_Staircase.GetRef())
male.MoveTo(alias_Staircase.GetRef())
;END CODE
EndFunction
;END FRAGMENT

;BEGIN FRAGMENT Fragment_10
Function Fragment_10()
;BEGIN CODE
;at this stage player can chose to re-enter device or go to sleep
;END CODE
EndFunction
;END FRAGMENT

;BEGIN FRAGMENT Fragment_5
Function Fragment_5()
;BEGIN CODE
;This is the stage once player enters pillory
SetObjectiveCompleted(0)

utility.wait(0.2)

SetObjectiveDisplayed(10) ;breeding bull is on his way

Utility.wait(4) ;pause for dramatic tension

;enable the actors
male.enable()
guard.enable()

;Start the scene
LeadBull.Start()
;END CODE
EndFunction
;END FRAGMENT

;BEGIN FRAGMENT Fragment_4
Function Fragment_4()
;BEGIN CODE
;This stage starts once player enters cage
SetObjectiveDisplayed(0)
;END CODE
EndFunction
;END FRAGMENT

;BEGIN FRAGMENT Fragment_13
Function Fragment_13()
;BEGIN CODE
;the player chose to sleep

;Show message
BreedFemaleMsg.Show()
BreedFemaleMsg2.Show()
CM.DaysAsCattle += 300

utility.wait(0.5)
debug.messagebox("You are led back to your cage")
Game.FastTravel(MainCage)

;Cleanup
utility.wait(5)
male.Delete()
guard.delete()
ParentQuest.Stop()
SendModEvent("MeatFarm_EnableSkip")
Stop()
;END CODE
EndFunction
;END FRAGMENT

;END FRAGMENT CODE - Do not edit anything between this and the begin comment

Actor Male
Actor Guard
Actor player

Event OnInit()
	Male = Alias_male.GetActorRef()
	guard = Alias_guard.GetActorRef()
	player = Game.GetPlayer()
endEvent


Scene property LeadBull auto
Scene property GuardWalkAway auto
SexLabFramework property SexLab auto
MeatFarmCattleMenu property CM auto
Quest property ParentQuest auto
Message property BreedFemaleMsg auto
Message property BreedFemaleMsg2 auto
ObjectReference property MainCage auto


;;;;;;;;;;;;;;;;;;;;

ObjectReference pillory
bool function PillorySex2(Actor SexActor1, Actor SexActor2, ObjectReference pilloryRef) 
	;SexActor1 = the female, SexActor2 = the male

	pillory = pilloryRef
	sslBaseAnimation anim1 = SexLab.GetAnimationByName("$ZazAP_PillorySex01")
	sslBaseAnimation anim2 = SexLab.GetAnimationByName("$ZazAP_PillorySex02")

	sslBaseAnimation[] anims = new sslBaseAnimation[2]
	anims[0] = anim1
	anims[1] = anim2

	;Custom timers (pillory sex has 7 stages)
	float[] timers = Utility.CreateFloatArray(7,30)
	timers[0] = 10 ;male hasn't penetrated, female is shaking her head
	timers[3] = 0  ;male is slapping the female's ass?
	timers[7] = 1 ;orgasm sound stage?
	;All other stages of the animation are thus set to 30s (payer can still skip if desired)

	;debug.MessageBox(sslUtility.GetAnimationNames(anims))

	sslThreadModel thread = SexLab.NewThread()
	thread.AddActor(SexActor1)
	thread.AddActor(SexActor2)
	thread.DisableUndressAnimation(SexActor1)
	thread.CenterOnObject(pillory)
	thread.SetAnimations(anims)
	Thread.SetHook("MeatFarmPillorySexFemale")
	RegisterForModEvent("HookAnimationEnd_MeatFarmPillorySexFemale", "myAnimEndEventHandler2")
	thread.VictimRef = none
	thread.IsAggressive = true
	thread.SetBedding(0)
	thread.DisableBedUse()
	thread.DisableRagdollEnd(SexActor1, disabling = True)
	thread.DisableRagdollEnd(SexActor2, disabling = True)

	;Make the scene longer
	thread.SetTimers(timers)

	Pillory.Disable()

	if !thread.StartThread()
		debug.messagebox("PillorySex thread start failed")
		return false
	else
		;Debug.SendAnimationEvent(PlayerRef, "IdleChairExitStart")
		return true
	endif
endfunction

Event myAnimEndEventHandler2(int tid, bool HasPlayer)
	Pillory.Enable()
	setStage(45)
endEvent
